unit fAddTool;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, TB2Item, TBX, TB2Dock, TB2Toolbar;

type
  TfmAddTool = class(TForm)
    bOk: TButton;
    Label4: TLabel;
    edCaption: TEdit;
    Label1: TLabel;
    procedure bOkClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure fmAddToolTryCreate;

var
  fmAddTool: TfmAddTool;

implementation

{$R *.DFM}

uses unit1, fEditTools, inifiles;

procedure fmAddToolTryCreate;
begin
  if not assigned(fmAddTool) then
   fmAddTool := TfmAddTool.create(form1);
end;

function CaptionFound(caption: string): boolean;
var
  ini: TIniFile;
  sl : TStringList;
  i: integer;
begin
  result := false;
  ini := TIniFile.create(inipath);
  sl := TStringList.create;
  try
    ini.ReadSections(sl);
    for i := 0 to sl.count - 1 do begin
      if sl.strings[i] = caption then begin
        result := true;
        break;
      end;
    end;
  finally
    ini.free;
    sl.free;
  end;

end;

procedure CreateIniSection(section: string);
var
  ini: TIniFile;
begin
  ini := TIniFile.create(inipath);
  try
    ini.WriteString(section, 'program', '');
    ini.WriteString(section, 'params', '');
    ini.WriteString(section, 'captureoutput', 'false');
    ini.WriteString(section, 'startindir', '');
    ini.WriteString(section, 'parserule', '');
    ini.WriteString(section, 'scrolltolastline', 'false');
    ini.WriteString(section, 'pause', 'false');    
  finally
    ini.free;
  end;
end;

procedure TfmAddTool.bOkClick(Sender: TObject);
var idx: integer;
begin
  if edCaption.text = '' then begin
    showmessage('You must enter a button caption');
    exit;
  end;
  if CaptionFound(edCaption.text) then begin
    showmessage('Caption is already in use by another button');
    exit;
  end;
  CreateIniSection(edCaption.text);
  ModalResult := 1;
  self.close;
  fmEditToolsTryCreate;
  fmEditTools.Show;
  idx := fmEditTools.FindIdxByName(edCaption.text);
  fmEditTools.close;
  fmEditTools.lbtoolsidx := idx;
  fmEditTools.ShowModal;
end;

end.
